<template>
  <div class="card card-lg h-100">
    <div class="card-body p-0">
      <div class="table-responsive table-projects-outputs-history">
        <table class="table table-vcenter datatable small card-table">
          <thead>
            <tr>
              <th class="text-center fit">State</th>
              <th class="p-0">Details</th>
              <th class="fit"></th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="job in jobs"
              :key="job.index"
              class="cursor-pointer clickable-row"
              :class="isActive(job.id) ? 'active' : ''"
              @click="setActiveJob(job)"
            >
              <td class="text-center fit">
                <div class="align-text-top">
                  <a
                    class="cursor-pointer"
                    :class="failed(job) ? 'text-danger' : 'text-output-history'"
                  >
                    <FilesOffIcon v-if="failed(job)" />
                    <StackIcon v-else />
                  </a>
                </div>
              </td>
              <td class="small p-0 py-1">
                <div>
                  <span v-if="job.title" class="mb-0">{{ job.title }}</span>
                  <span v-else class="mb-0"
                    >Execution #{{ job.id.substr(0, 4) }}</span
                  >
                </div>
                <div class="text-muted mt-1">
                  <span v-if="scenario(job)">
                    <span class="name">{{ scenario(job).title }}</span>
                    <span class="ml-1 v">{{ scenario(job).version }}</span>
                  </span>
                </div>
                <div class="text-muted">
                  <span class="date-tooltip date-timeago">
                    {{ job.execution_datetime | timeago }}
                  </span>
                </div>
              </td>
              <td class="text-right px-1 fit">
                <div class="align-text-top mt-3 cursor-not-allowed">
                  <CircleOffIcon
                    v-if="failed(job)"
                    class="dropdown-item-icon mr-0 ml-0 icon-sm disabled-action"
                  />
                  <a
                    v-else
                    :href="downloadOutput(job)"
                    rel="noopener noreferrer"
                  >
                    <DownloadIcon
                      class="dropdown-item-icon mr-0 ml-0 text-green icon-sm"
                    />
                  </a>
                  <DotsVerticalIcon
                    class="dropdown-item-icon mr-0 ml-0 icon-sm disabled-action"
                  />
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    jobs: {
      type: Array,
      default: () => [],
    },
  },
  async fetch() {
    const id = this.$nuxt.$route.params.id;
    const store = this.$nuxt.context.store;
    const scenarios = store.getters['scenarios/allScenarios'];
    if (!scenarios || scenarios.length === 0) {
      await store.dispatch('scenarios/fetchProjectScenarios', {
        projectId: id,
      });
    }
  },
  computed: {
    failed() {
      return (job) => {
        return job.response && job.response.error !== undefined;
      };
    },
    scenario() {
      return (job) => {
        return this.$nuxt.context.store.getters['scenarios/singleScenario'](
          job.scenario.id
        );
      };
    },
    isActive() {
      return (id) => {
        return id === this.$nuxt.context.store.getters['ui/activeJob'].id;
      };
    },
    downloadOutput() {
      return (job) => {
        if (job.response && job.response.error === undefined) {
          let token = this.$auth.strategy.token.get().split(' ');
          token = token[1];
          return `${this.$config.apiRoot}/projects/${this.$nuxt.$route.params.id}/jobs/${job.id}/outputs?access_token=${token}`;
        }
        return '#';
      };
    },
  },
  beforeMount() {
    const jobId = this.$nuxt.$route.query?.job;
    if (jobId) {
      this.$nuxt.context.store.dispatch('ui/setActiveJob', {
        newActiveJob: {
          id: jobId,
        },
      });
      const query = Object.assign({}, this.$nuxt.$route.query);
      delete query.job;
      this.$nuxt.$router.replace({ query });
    }
  },
  methods: {
    setActiveJob(job) {
      this.$nuxt.context.store.dispatch('ui/setActiveJob', {
        newActiveJob: {
          id: job.id,
        },
      });
      this.loadNextParameters(job.scenario.id);
    },
    loadNextParameters(scenarioId) {
      const projectId = this.$nuxt.$route.params.id;
      const store = this.$nuxt.context.store;
      store.dispatch('parameters/loadParameters', {
        projectId,
        scenarioId,
      });
    },
  },
};
</script>
